
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */
 
 
package org.aspectj.ajde;

import java.util.List;

/**
 * @author	Mik Kersten
 */
public interface ProjectPropertiesAdapter {

    public String getProjectName();

    public String getRootProjectDir();

	public List getBuildConfigFiles();
	
	public String getDefaultBuildConfigFile();
	
	/**
	 * @return The last selected build configuration for this project.  If no selection
	 * 			is present the default build config file for this project is returned.
	 */ 
	public String getLastActiveBuildConfigFile();

    public List getProjectSourceFiles();

    public String getProjectSourcePath();

    public String getClasspath();

    public String getOutputPath();

    public String getAjcWorkingDir();

	// @todo: move to build options
    public String getBootClasspath();
    
    // @todo: move all below to execution options
    public String getClassToExecute();

    public String getExecutionArgs();

    public String getVmArgs();
}
