
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde.internal;

import java.util.*;
import java.io.*;
import org.aspectj.asm.*;
import org.aspectj.ajde.*;
import org.aspectj.util.ConfigParser;

/**
 * @author Mik Kersten
 */
public class LstBuildConfigFileParser extends ConfigParser {

	private List importedFiles = new ArrayList();
	private List problemEntries = new ArrayList();

	private String currFilePath;

	public LstBuildConfigFileParser(String currFilePath) {
		this.currFilePath = currFilePath;		
	}  

    protected void showWarning(String message) {
    	problemEntries.add(message);
    }
    
	protected void parseImportedConfigFile(String relativeFilePath) {
		importedFiles.add(makeFile(relativeFilePath));
		super.files.add(new File(relativeFilePath));
		super.parseImportedConfigFile(relativeFilePath);	
	} 
	
    protected void showError(String message) {
        problemEntries.add(message);
    }
	
	public List getImportedFiles() {
		return importedFiles;
	}
	
	public List getProblemEntries() {
		return problemEntries;	
	}
}



