
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */
 
package org.aspectj.ajde.internal;

import java.util.*;
import java.io.*;
import org.aspectj.compiler.base.*;
import org.aspectj.compiler.crosscuts.*;
//import org.aspectj.ajde.compiler.AjdeCompiler;
//import org.aspectj.compiler.structure.*;
//import org.aspectj.compiler.structure.associations.*;

/**
 * Utility class for building a structure model for a given compile. Typical command-line usage: <BR>
 * &nbsp;&nbsp;&gt; <TT>java org.aspectj.tools.ajde.StructureManager @&lt;config-file&gt;.lst</TT>
 */
public class StructureUtilities {

//    private static StructureManager structureManager = new StructureManager();

    /**
     * Usage is the same as <CODE>org.aspectj.tools.ajc.Main</CODE>.
     */
//    public static void main(String[] args) throws IOException {
//        StructureNode model = buildStructureModel(args);
//        if (model == null) {

//        } else {
//            dumpStructure(model, "");
//        }
//    }

    /**
     * Compiles and builds a structure model.
     *
     * @return  the node representing the root for the structure model
     */
//    public static StructureNode buildStructureModel(String[] args) {
//        new StructureBuilder().buildStructure(args);
//        return structureManager.getStructureModel();
//    }

    /**
     * Dumps the structure model by walking the
     * corresponding tree.
     *     * @param   node    node to start traversal at, typically the root
     * @param   indent  whitespace accumulator for pretty-printing
     */
//    public static void dumpStructure(StructureNode node, String indent) {
//        if (node == null) return;
//        Syste.println(indent + node); 
//        if (node.getChildren() != null) {
//            for (Iterator it = node.getChildren().iterator(); it.hasNext(); ) {
//                dumpStructure((StructureNode)it.next(), indent + "  ");
//            }
//        }
//        if (node instanceof ProgramElementNode) {
//            if (((ProgramElementNode)node).getRelations() != null) {
//                for (Iterator it = ((ProgramElementNode)node).getRelations().iterator(); it.hasNext(); ) {
//                    dumpStructure((StructureNode)it.next(), indent + "  ");
//                }
//            }
//        }
//    }
//
//    private static class StructureBuilder extends org.aspectj.tools.ajc.Main {
//        public void buildStructure(String[] args) {
//            compile(args);
//        }
//
//        public JavaCompiler getCompiler() {
//            if (compiler != null) return compiler;
//            if (compiler == null) {
//                if (errorHandler == null) {
//                    compiler = new AjdeCompiler(structureManager);
//                }
//            }
//            return compiler;
//        }
//    }
}
