
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde.ui.swing;

import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;
import org.aspectj.asm.*;
import org.aspectj.ajde.*;

public class BuildConfigPopupMenu extends JPopupMenu {

	public BuildConfigPopupMenu(final AbstractAction action) {
		java.util.List configFiles = Ajde.getDefault().getProjectProperties().getBuildConfigFiles();
		for (Iterator it = configFiles.iterator(); it.hasNext(); ) {
	    	final String buildConfig = (String)it.next();
	    	JMenuItem buildItem = new JMenuItem(buildConfig);
	    	buildItem.setFont(AjdeWidgetStyles.DEFAULT_LABEL_FONT);
	    	buildItem.addActionListener(
	    		new ActionListener() {
		    		public void actionPerformed(ActionEvent e) {
		    			Ajde.getDefault().getConfigurationManager().setActiveConfigFile(buildConfig);
				        Ajde.getDefault().getBuildManager().build();
				        action.actionPerformed(e);
					}
	    		});
	    	buildItem.setIcon((Icon)AjdeUIManager.getDefault().getIconRegistry().getStructureIcon(ProgramElementNode.Kind.FILE_LST).getIconResource());
	    	this.add(buildItem);
		}
	}
}
