
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */
     
package org.aspectj.ajde.ui.swing;

import java.util.*;
import java.awt.Component;
import java.awt.Color;
import java.awt.Font;
import java.awt.font.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import org.aspectj.ajde.Ajde;
import org.aspectj.asm.*;
import org.aspectj.asm.associations.*;
import org.aspectj.asm.views.*;
import org.aspectj.ajde.ui.*;

/**
 * @author  Mik Kersten
 */
class StructureViewTreeListener implements TreeSelectionListener, MouseListener {
    private StructureTree tree;
	private SwingTreeViewNode lastSelectedNode = null;

    public StructureViewTreeListener(StructureTree tree) {
        this.tree = tree;
    }

    public void valueChanged(TreeSelectionEvent e) { }

    public void mouseEntered(MouseEvent e) { }

    public void mouseExited(MouseEvent e) { }

    public void mousePressed(MouseEvent e) { }

    public void mouseReleased(MouseEvent e) { }

    public void mouseClicked(MouseEvent e) {
        navigate(e);
    }

    public void navigate(MouseEvent e) {
        SwingTreeViewNode treeNode = (SwingTreeViewNode)tree.getLastSelectedPathComponent();
		if (treeNode == null || lastSelectedNode == treeNode) return;
		lastSelectedNode = treeNode;
		
		//if (e.getClickCount() == 2) {
		Ajde.getDefault().getStructureViewManager().fireNavigationAction(
			treeNode.getStructureNode()
		);
		//}
    }   
}


