/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.base.parser;

import org.aspectj.compiler.base.JavaCompiler;
import org.aspectj.compiler.base.ast.*;

public class Token implements JavaConstants {
    public Token(int _kind, String _image, boolean _isIdentifier) {
        kind = _kind;
        image = _image;
        isIdentifier = _isIdentifier;
    }

    public int kind;
    // an optimization would be to encode this in the value of kind
    boolean isIdentifier;

    public int startPosition, endPosition;
    public String image;

    public boolean isIdentifier() {
        return isIdentifier;
    }

    public Expr getExpr(SourceLocation source) {
        return null;
    }

    public Expr getNegativeExpr(SourceLocation source) {
        return null;
    }

    public Token specialToken;

    public String toString() {
        if (specialToken != null) {
            return "Token("+image+", " + specialToken + ")";
        } else {
            return "Token("+image+")";
        }
    }
}
