/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.crosscuts.ast;
import org.aspectj.compiler.base.ast.*;
import org.aspectj.compiler.crosscuts.joinpoints.*;

import org.aspectj.compiler.base.JavaCompiler;

import java.util.*;
import org.aspectj.util.InvertableSet;

/**
  * @grammar initialization(constructorPattern)
  */
public class InitializerPcd extends KindedPcd {
    public String getKind() {
        return "initialization";
    }
    public int getJpKind() {
        return JoinPoint.INITIALIZER_EXECUTION;
    }    
    
    //BEGIN: Generated from @child and @property
    
    public InitializerPcd(SourceLocation location, DecPattern _pattern) {
        super(location, _pattern);
    
    }
    protected InitializerPcd(SourceLocation source) {
        super(source);
    }
    
    public ASTObject copyWalk(CopyWalker walker) {
        InitializerPcd ret = new InitializerPcd(getSourceLocation());
        ret.preCopy(walker, this);
        if (pattern != null) ret.setPattern( (DecPattern)walker.process(pattern) );
        return ret;
    }
    
    
    public String getDefaultDisplayName() {
        return "InitializerPcd()";
    }
    
    //END: Generated from @child and @property
}

