/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */
package org.aspectj.compiler.crosscuts.joinpoints;

import org.aspectj.compiler.base.ast.*;
import org.aspectj.compiler.crosscuts.ast.*;

import org.aspectj.compiler.base.JavaCompiler;
import org.aspectj.util.JavaStrings;

import java.util.*;


public class ConstructorCallJp extends CallJp {
    public ConstructorCallJp(NewExpr callExpr, JoinPoint enclosingJp) {
        super(callExpr, enclosingJp);
    }

    public static final Kind KIND = new Kind("constructor-call", CONSTRUCTOR_CALL);

    public Kind getKind() { return KIND; }

    public boolean isMethodCall() { return false; }

    public Type getTargetExprType() { return null; }

    public Type getTargetType() {
        return getCallExpr().getType();
    }

    protected ASTObject makeInnerCall(Expr targetExpr, Exprs innerArgs) {
        AnyCallExpr innerCall = getCallExpr();
        NewInstanceExpr newInstance = (NewInstanceExpr)innerCall;
        TypeDec saveTypeDec = newInstance.getTypeDec();
        newInstance.setTypeDec(null);
        newInstance = (NewInstanceExpr)newInstance.copy();
        newInstance.setTypeDec(saveTypeDec);
        innerCall = newInstance;
        innerCall.setArgs(innerArgs);
        //if (makeCalledThisExpr() != null) innerCall.setExpr(makeCalledThisExpr());
        return innerCall;
    }
}
