/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.base;

/**
 * Encapsulates the current development evironment.
 * TODO: Should probably be in org.aspectj.ajde.common or something
 */
public class Modes {

    public final static String COMMAND_LINE = "commandline";
    public final static String GUI          = "gui";
    public final static String JBUILDER     = "jbuilder";
    public final static String JBUILDER3    = "jbuilder3";
    public final static String JBUILDER4    = "jbuilder4";
    public final static String FORTE        = "forte";
    public final static String UNSET        = "unset";

    private static String mode = UNSET;

    public static void setMode(String _mode) {
        mode = _mode;
    }

    public static String getMode() {
        return mode;
    }

    public static boolean isIde() {
        return getMode().equals(Modes.JBUILDER)
            || getMode().equals(Modes.JBUILDER3)
            || getMode().equals(Modes.JBUILDER4)
            || getMode().equals(Modes.FORTE);
    }

    public static boolean isJBuilder() {
        return getMode().equals(Modes.JBUILDER)
            || getMode().equals(Modes.JBUILDER3)
            || getMode().equals(Modes.JBUILDER4)
            ;
    }

    public static boolean isForte() {
        return getMode().equals(Modes.FORTE);
    }
}
