/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.gui;

import org.aspectj.debugger.base.*;

import java.util.Iterator;
import java.util.List;
import com.sun.jdi.ArrayReference;
import com.sun.jdi.ClassNotLoadedException;
import com.sun.jdi.Value;

public class AJArrayValueNode extends AJValueNode {
    public AJArrayValueNode(AJValueGetter getter) {
        super(getter);
        setType(AJIcons.ARRAY_ICON);
    }

    public boolean isArray() { return true; }

    public void showKids() {
        if (getChildCount() == 0)
            showMembers();
    }

    public void hideKids() {

    }

    private void showMembers() {
        hideMembers();
        try {
            ArrayReference array = (ArrayReference) g().getValue();
            for (int i = 0; i < array.length(); i++) {
                AJValueNode valueNode = AJValueNodeFactory.make(array, i);
                this.add(valueNode);
            }
        } catch (Exception e) { Util.ex(e); }    }

    private void hideMembers() {

    }

    // ASPECT: Put constraints on this so that it doesn't print off the screen
    private String getArrayString() {
        int i = 0;
        String str = "";
        while (i < children.size() - 1) {
            str += ((AJValueNode) children.get(i++)).getValueString() + ", ";
        }
        if (i >= 0) {
            str += ((AJValueNode) children.get(i)).getValueString();
        }
        return str;

    }

    public String getValueString() {
        String type = "no class loaded";
        try {
            type = g().getTypeName();
        } catch (ClassNotLoadedException e) {}
        return type;
        //TODO: Maybe later
        //return "{ " + getArrayString() + " }";
    }
}