/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.gui;

import org.aspectj.debugger.base.*;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import java.util.*;
import java.util.List;
import java.net.*;
import java.lang.reflect.*;

// For demo mode
import java.io.*;
import java.awt.*;
import javax.swing.*;

/**
 * Quite possibly the ugliest piece of crap I've ever written!!!!
 */
public class AJIcons {

    // Ints here
    private static int count = 0;
	public final static int BAD_ICON = count++;
	public final static int DEFAULT_ICON = count++;
	public final static int THREAD_ICON = count++;
	public final static int THREADGROUP_ICON = count++;
	public final static int ROOT_ICON = count++;
	public final static int STACKFRAME_ICON = count++;
	public final static int THREAD_BREAKPOINT_ICON = count++;
	public final static int THREAD_SUSPENDED_ICON = count++;
	public final static int THREAD_RUNNING_ICON = count++;
	public final static int INVALID_ICON = count++;
	public final static int LOCAL_VARIABLE_ICON = count++;
	public final static int BOOLEAN_ICON = count++;
	public final static int BYTE_ICON = count++;
	public final static int CHAR_ICON = count++;
	public final static int DOUBLE_ICON = count++;
	public final static int FLOAT_ICON = count++;
	public final static int INTEGER_ICON = count++;
	public final static int LONG_ICON = count++;
	public final static int OBJECT_ICON = count++;
	public final static int SHORT_ICON = count++;
	public final static int ARRAY_ICON = count++;
	public final static int EXECUTABLE_ICON = count++;
	public final static int VERIFIED_BREAKPOINT_ICON = count++;
	public final static int UNVERIFIED_BREAKPOINT_ICON = count++;
	public final static int NULL_OBJECT_ICON = count++;
	public final static int DOCUMENT_ICON = count++;
	public final static int FOLDER_ICON = count++;
	public final static int STOP_ICON = count++;
	public final static int CONT_ICON = count++;
	public final static int SUSPEND_ICON = count++;
	public final static int RESUME_ICON = count++;
	public final static int NEXT_ICON = count++;
	public final static int STEPI_ICON = count++;
	public final static int STEPUP_ICON = count++;
	public final static int STEP_ICON = count++;
	public final static int QUIT_ICON = count++;
	public final static int RUN_ICON = count++;
	public final static int PACKAGE_ICON = count++;
	public final static int BLANK_ICON = count++;
	public final static int ADVICE_ICON = count++;
	public final static int ASPECT_ICON = count++;
	public final static int WHERE_ICON = count++;
	public final static int HELP_ICON = count++;
	public final static int ABOUT_ICON = count++;
	public final static int PRINT_ICON = count++;
	public final static int FIELDS_ICON = count++;
	public final static int DUMP_ICON = count++;
	public final static int EVALUATE_ICON = count++;
	public final static int LOCALS_ICON = count++;
	public final static int USE_ICON = count++;
	public final static int CLEAR_ICON = count++;
	public final static int DISCONNECT_ICON = count++;

	public final static int METHOD_ICON = count++;
	public final static int METHOD_PUBLIC_ICON = count++;
	public final static int METHOD_PACKAGE_ICON = count++;
	public final static int METHOD_PROTECTED_ICON = count++;
	public final static int METHOD_PRIVATE_ICON = count++;
	public final static int METHOD_STATIC_PUBLIC_ICON = count++;
	public final static int METHOD_STATIC_PACKAGE_ICON = count++;
	public final static int METHOD_STATIC_PROTECTED_ICON = count++;
	public final static int METHOD_STATIC_PRIVATE_ICON = count++;


	public final static int INTERFACE_ICON = count++;
	public final static int INTERFACE_PUBLIC_ICON = count++;
	public final static int INTERFACE_PACKAGE_ICON = count++;
	public final static int INTERFACE_PROTECTED_ICON = count++;
	public final static int INTERFACE_PRIVATE_ICON = count++;
	public final static int INTERFACE_STATIC_PUBLIC_ICON = count++;
	public final static int INTERFACE_STATIC_PACKAGE_ICON = count++;
	public final static int INTERFACE_STATIC_PROTECTED_ICON = count++;
	public final static int INTERFACE_STATIC_PRIVATE_ICON = count++;

	public final static int CLASS_ICON = count++;
	public final static int CLASS_PUBLIC_ICON = count++;
	public final static int CLASS_PACKAGE_ICON = count++;
	public final static int CLASS_PROTECTED_ICON = count++;
	public final static int CLASS_PRIVATE_ICON = count++;
	public final static int CLASS_STATIC_PUBLIC_ICON = count++;
	public final static int CLASS_STATIC_PACKAGE_ICON = count++;
	public final static int CLASS_STATIC_PROTECTED_ICON = count++;
	public final static int CLASS_STATIC_PRIVATE_ICON = count++;

	public final static int FIELD_ICON = count++;
	public final static int FIELD_PUBLIC_ICON = count++;
	public final static int FIELD_PACKAGE_ICON = count++;
	public final static int FIELD_PROTECTED_ICON = count++;
	public final static int FIELD_PRIVATE_ICON = count++;
	public final static int FIELD_STATIC_PUBLIC_ICON = count++;
	public final static int FIELD_STATIC_PACKAGE_ICON = count++;
	public final static int FIELD_STATIC_PROTECTED_ICON = count++;
	public final static int FIELD_STATIC_PRIVATE_ICON = count++;

	public final static int CTR_ICON = count++;
	public final static int CTR_PUBLIC_ICON = count++;
	public final static int CTR_PACKAGE_ICON = count++;
	public final static int CTR_PROTECTED_ICON = count++;
	public final static int CTR_PRIVATE_ICON = count++;
	public final static int CTR_STATIC_PUBLIC_ICON = count++;
	public final static int CTR_STATIC_PACKAGE_ICON = count++;
	public final static int CTR_STATIC_PROTECTED_ICON = count++;
	public final static int CTR_STATIC_PRIVATE_ICON = count++;


    public final static int BREAKPOINTS_ICON        = count++;
//      public final static int BREAKPOINT_ICON         = count++;
    public final static int MAIN_ICON               = count++;
    public final static int THREADS_ICON            = count++;
//        public final static int THREAD_ICON             = count++;
//      public final static int THREAD_CURRENT_ICON     = count++;
//      public final static int THREAD_RUNNING_ICON     = count++;
//      public final static int VARIABLE_ICON           = count++;
    public final static int WATCHES_ICON            = count++;
    public final static int WATCH_ICON            = count++;
    public final static int CATCH_ICON = count++;
    public final static int WATCHVAR_ICON = count++;
    public final static int INITIALIZER_ICON = count++;
    public final static int VARIABLES_ICON = count++;
    public final static int CLASSES_ICON = count++;
    
    //new-main
    public final static int OUTPUT_ICON = count++;
    //end-new-main

    public final static int NUM_ICONS = count;

    private static String mode = Modes.UNSET;
    public static void init() {
        init(Modes.getMode());
    }
    private static void init(String _mode) {
        AJIcons.mode = _mode;
        if (icons != null) return;
        icons = new Icon[NUM_ICONS];
        try {
            if (mode.equals(Modes.GUI)) {
                createStandAloneIcons();
                validateIcons();
                return;
            } else if (mode.equals(Modes.JBUILDER3)) {
                createJBuilder3Icons();
                validateIcons();
                return;
            } else if (mode.equals(Modes.JBUILDER4)) {
                createJBuilder4Icons();
                validateIcons();
                return;
            } else if (mode.equals(Modes.FORTE)) {
                createForteIcons();
                validateIcons();
                return;
            }
        } catch (Exception e) {
            error(e);
            return;
        }
        throw new RuntimeException("Invalid icon mode: " + mode);
    }

    private static void error(Throwable t) {
        new ErrorLogger().log(t);
        t.printStackTrace();
        //AJUtil.ex(t);
    }

    private static boolean validateIcons() throws Exception {
        if (icons == null) {
            throw new RuntimeException("icons are null");
        }
        if (icons.length != NUM_ICONS) {
            throw new RuntimeException("icons.length != NUM_ICONS");
        }
        List nulls = new Vector();
        for (int i = 0; i < icons.length; i++) {
            if (getIcon(i) == null) {
                nulls.add(new Integer(i));
            }
        }
        if (nulls.size() > 1) {
            throw new RuntimeException("These icons are null: " +
                                       nulls + " of " + NUM_ICONS + " icons.");
        }
        return true;
    }

    private static Icon[] icons = null;

    public final static String FORTE_CLASS              = "src/class.gif";
    public final static String FORTE_INTERFACE          = "src/interface.gif";
    public final static String FORTE_VARIABLE_PUBLIC    = "src/variablePublic.gif";
    public final static String FORTE_VARIABLE_PRIVATE   = "src/variablePrivate.gif";
    public final static String FORTE_VARIABLE_PACKAGE   = "src/variablePackage.gif";
    public final static String FORTE_VARIABLE_PROTECTED = "src/variableProtected.gif";
    public final static String FORTE_METHOD_PRIVATE     = "src/methodPrivate.gif";
    public final static String FORTE_METHOD_PACKAGE     = "src/methodPackage.gif";
    public final static String FORTE_METHOD_PROTECTED   = "src/methodProtected.gif";
    public final static String FORTE_METHOD_PUBLIC      = "src/methodPublic.gif";
    public final static String FORTE_ERROR              = "src/error.gif";
    public final static String FORTE_HISTORY            = "html/history.gif";
    public final static String FORTE_TRACE_INFO         = "actions/traceInto.gif";
    public final static String FORTE_REFRESH            = "html/refresh.gif";
    public final static String FORTE_JAR_FS             = "jarFS.gif";
    public final static String FORTE_DEFAULT_NODE       = "defaultNode.gif";
    public final static String FORTE_DEFAULT_FOLDER     = "defaultFolder.gif";
    public final static String FORTE_LOCALS_FS          = "localFS.gif";
    public final static String FORTE_FOLDER             = "defaultFolder.gif";
    public final static String FORTE_STOP               = "actions/addBreakpoint.gif";
    public final static String FORTE_RUN                = "actions/startDebugger.gif";    
    public final static String FORTE_QUIT               = "actions/finishDebugger.gif";
    public final static String FORTE_HELP               = "actions/showHelp.gif";
    public final static String FORTE_TOGGLE_BREAKPOINT  = "actions/toggleBreakpoint.gif";
    public final static String FORTE_STEPOUT            = "actions/stepOut.gif";
    public final static String FORTE_STEP               = "actions/traceInto.gif";
    public final static String FORTE_NEXT               = "actions/traceOver.gif";
    public final static String FORTE_INITIALIZER        = "src/initializer.gif";
    public final static String FORTE_CTR_PRIVATE        = "src/constructorPrivate.gif";
    public final static String FORTE_CTR_PACKAGE        = "src/constructorPackage.gif";
    public final static String FORTE_CTR_PROTECTED      = "src/constructorProtected.gif";
    public final static String FORTE_CTR_PUBLIC         = "src/constructorPublic.gif";
    public final static String FORTE_CTRS               = "src/constructors.gif";
    public final static String FORTE_METHODS            = "src/methods.gif";
    public final static String FORTE_VARIABLES          = "src/variables.gif";
    public final static String FORTE_WHERE              = "actions/goToCursor.gif";
    public final static String FORTE_CLEAR              = "actions/cut.gif";
    public final static String FORTE_RESUME             = "resume.gif";
    public final static String FORTE_DISCONNECT         = "actions/delete.gif";
    public final static String FORTE_STEPI              = "actions/goToCursor.gif";
    public final static String FORTE_CONT               = "actions/go.gif";
    public final static String FORTE_FIELDS             = "src/variables.gif";
    public final static String FORTE_BAD                = "src/error.gif";
    public final static String FORTE_USE                = "actions/undock.gif";
    public final static String FORTE_PRINT              = "actions/print.gif";
    public final static String FORTE_DUMP               = "actions/find.gif";
    public final static String FORTE_DEFAULT            = "actions/empty.gif";
    public final static String FORTE_PACKAGE            = "defaultFolderOpen.gif";
    public final static String FORTE_ADDWATCH           = "actions/addWatch.gif";
    public final static String FORTE_BREAKPOINTS        = "breakpoints.gif";
    public final static String FORTE_BREAKPOINT         = "breakpoint.gif";
    public final static String FORTE_MAIN               = "actions/debuggerView.gif";
    public final static String FORTE_THREADS            = "threads.gif";
    public final static String FORTE_THREADGROUP        = "threadGroup.gif";
    public final static String FORTE_THREADGROUP_CURRENT= "threadGroupCurrent.gif";
    public final static String FORTE_THREAD_SUSPENDED   = "threadSuspended.gif";
    public final static String FORTE_THREAD_CURRENT     = "threadCurrent.gif";
    public final static String FORTE_THREAD_RUNNING     = "threadRunning.gif";
    public final static String FORTE_VARIABLE           = "variable.gif";
    public final static String FORTE_WATCHES            = "watches.gif";
    public final static String FORTE_CALLSTACK          = "callstack.gif";
    public final static String FORTE_WATCH              = "watch.gif";
    //public final static String FORTE_SUSPEND            = "suspend.gif";
    public final static String FORTE_SUSPEND            = "actions/suspend.gif";
    public final static String FORTE_OUTPUT             = "frames/output.gif";


    public final static String FORTE_CONFIG             = "org/openide/resources/";
    public final static String FORTE_CORE               = "org/netbeans/core/resources/";
    public final static String FORTE_DEBUGGER           = "org/netbeans/modules/debugger/resources/";
    private static Icon getIcon(String prefix, String string, String jar) {
        String iconString = prefix + string;
        URL url = ClassLoader.getSystemResource(iconString);
        if (url == null) {
            //throw
            error(new RuntimeException("image " + iconString + " usually found in " + jar + " is null!"));
        }
        return new ImageIcon(url);
    }
    private static Icon fi(String s) {
        return getIcon(FORTE_CONFIG, s, "lib/openide.jar");
    }
    private static Icon cfi(String s) {
        return getIcon(FORTE_CORE, s, "lib/developer.jar (for Forte) OR lib/core.jar (for Netbeans)");
    }
    private static Icon dfi(String s) {
        return getIcon_(FORTE_DEBUGGER, s, "modules/debuggerCore.jar");
    }
    private static Icon getIcon_(String prefix, String string, String jar) {
        String iconString = prefix + string;
        URL url = null;
        try {
            Class type = Class.forName("org.openide.TopManager");
            url = ((ClassLoader)type.getMethod("currentClassLoader", new Class[]{}).
                   invoke
                   (type.getMethod("getDefault", new Class[]{}).invoke
                    (null, new Object[]{}), new Object[]{})).getResource(iconString);
        } catch (Throwable t) {
            error(t);
        }
        if (url == null) {
            url = ClassLoader.getSystemResource(iconString);
        }
        if (url == null) {
            error(new RuntimeException("image " + iconString + " usually found in " + jar + " is null!"));
        }
        return new ImageIcon(url);
    }

    private static void createForteIcons() throws Exception {
        createStandAloneIcons();
        try {
            createActualForteIcons();
        } catch (ClassNotFoundException cnfe) {
            throw new RuntimeException("Please include the Forte jar");
        }
    }

    private static void createActualForteIcons() throws ClassNotFoundException {
        try { icons[INTERFACE_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_PUBLIC_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_PACKAGE_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_PROTECTED_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_PRIVATE_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_STATIC_PUBLIC_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_STATIC_PACKAGE_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_STATIC_PROTECTED_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }
        try { icons[INTERFACE_STATIC_PRIVATE_ICON] = fi(FORTE_INTERFACE); }
        catch (Exception e) { error(e); }

        try { icons[CLASS_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_PUBLIC_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_PACKAGE_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_PROTECTED_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_PRIVATE_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_STATIC_PUBLIC_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_STATIC_PACKAGE_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_STATIC_PROTECTED_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASS_STATIC_PRIVATE_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }
        try { icons[CLASSES_ICON] = fi(FORTE_CLASS); }
        catch (Exception e) { error(e); }

        try { icons[METHOD_ICON] = fi(FORTE_METHOD_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_PUBLIC_ICON] = fi(FORTE_METHOD_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_PACKAGE_ICON] = fi(FORTE_METHOD_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_PROTECTED_ICON] = fi(FORTE_METHOD_PROTECTED); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_PRIVATE_ICON] = fi(FORTE_METHOD_PRIVATE); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_STATIC_PUBLIC_ICON] = fi(FORTE_METHOD_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_STATIC_PACKAGE_ICON] = fi(FORTE_METHOD_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_STATIC_PROTECTED_ICON] = fi(FORTE_METHOD_PROTECTED); }
        catch (Exception e) { error(e); }
        try { icons[METHOD_STATIC_PRIVATE_ICON] = fi(FORTE_METHOD_PRIVATE); }
        catch (Exception e) { error(e); }

        try { icons[FIELD_ICON] = fi(FORTE_VARIABLE_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_PUBLIC_ICON] = fi(FORTE_VARIABLE_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_PACKAGE_ICON] = fi(FORTE_VARIABLE_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_PROTECTED_ICON] = fi(FORTE_VARIABLE_PROTECTED); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_PRIVATE_ICON] = fi(FORTE_VARIABLE_PRIVATE); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_STATIC_PUBLIC_ICON] = fi(FORTE_VARIABLE_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_STATIC_PACKAGE_ICON] = fi(FORTE_VARIABLE_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_STATIC_PROTECTED_ICON] = fi(FORTE_VARIABLE_PROTECTED); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_STATIC_PRIVATE_ICON] = fi(FORTE_VARIABLE_PRIVATE); }
        catch (Exception e) { error(e); }

        try { icons[CTR_ICON] = fi(FORTE_CTR_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[CTR_PUBLIC_ICON] = fi(FORTE_CTR_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[CTR_PACKAGE_ICON] = fi(FORTE_CTR_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[CTR_PROTECTED_ICON] = fi(FORTE_CTR_PROTECTED); }
        catch (Exception e) { error(e); }
        try { icons[CTR_PRIVATE_ICON] = fi(FORTE_CTR_PRIVATE); }
        catch (Exception e) { error(e); }
        try { icons[CTR_STATIC_PUBLIC_ICON] = fi(FORTE_CTR_PUBLIC); }
        catch (Exception e) { error(e); }
        try { icons[CTR_STATIC_PACKAGE_ICON] = fi(FORTE_CTR_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[CTR_STATIC_PROTECTED_ICON] = fi(FORTE_CTR_PROTECTED); }
        catch (Exception e) { error(e); }
        try { icons[CTR_STATIC_PRIVATE_ICON] = fi(FORTE_CTR_PRIVATE); }
        catch (Exception e) { error(e); }


        try { icons[FOLDER_ICON] = fi(FORTE_FOLDER); }
        catch (Exception e) { error(e); }
        try { icons[STOP_ICON] = fi(FORTE_STOP); }
        catch (Exception e) { error(e); }
        try { icons[RUN_ICON] = fi(FORTE_RUN); }
        catch (Exception e) { error(e); }
        try { icons[QUIT_ICON] = fi(FORTE_QUIT); }
        catch (Exception e) { error(e); }
        try { icons[HELP_ICON] = fi(FORTE_HELP); }
        catch (Exception e) { error(e); }
//      fi(FORTE_TOGGLE_BREAKPOINT  = "actions/toggleBreakpoint.gif";
        try { icons[STEPUP_ICON] = fi(FORTE_STEPOUT); }
        catch (Exception e) { error(e); }
//          try { icons[SUSPEND_ICON] = dfi(FORTE_SUSPEND); }
//          catch (Exception e) { error(e); }
        try { icons[SUSPEND_ICON] = fi(FORTE_SUSPEND); }
        catch (Exception e) { error(e); }
        try { icons[STEP_ICON] = fi(FORTE_STEP); }
        catch (Exception e) { error(e); }
        try { icons[NEXT_ICON] = fi(FORTE_NEXT); }
        catch (Exception e) { error(e); }
        try { icons[INITIALIZER_ICON] = fi(FORTE_INITIALIZER); }
        catch (Exception e) { error(e); }
//          try { icons[CTR_PRIVATE_ICON] = fi(FORTE_CTR_PRIVATE); }
//          catch (Exception e) { error(e); }
//          try { icons[CTR_PACKAGE_ICON] = fi(FORTE_CTR_PACKAGE); }
//          catch (Exception e) { error(e); }
//          try { icons[CTR_PROTECTED_ICON] = fi(FORTE_CTR_PROTECTED); }
//          catch (Exception e) { error(e); }
//          try { icons[CTRS_ICON] = fi(FORTE_CTRS); }
//          catch (Exception e) { error(e); }
//          try { icons[METHODS_ICON] = fi(FORTE_METHODS); }
//          catch (Exception e) { error(e); }
        try { icons[WHERE_ICON] = fi(FORTE_WHERE); }
        catch (Exception e) { error(e); }
        try { icons[CLEAR_ICON] = fi(FORTE_CLEAR); }
        catch (Exception e) { error(e); }
        //!!! need to find a resume
        try { icons[RESUME_ICON] = dfi(FORTE_RESUME); }
        catch (Exception e) { error(e); }
        try { icons[DISCONNECT_ICON] = fi(FORTE_DISCONNECT); }
        catch (Exception e) { error(e); }
        try { icons[STEPI_ICON] = fi(FORTE_STEPI); }
        catch (Exception e) { error(e); }
        try { icons[CONT_ICON] = fi(FORTE_CONT); }
        catch (Exception e) { error(e); }
        try { icons[FIELDS_ICON] = fi(FORTE_FIELDS); }
        catch (Exception e) { error(e); }
        try { icons[BAD_ICON] = fi(FORTE_BAD); }
        catch (Exception e) { error(e); }
        try { icons[USE_ICON] = fi(FORTE_USE); }
        catch (Exception e) { error(e); }
        try { icons[PRINT_ICON] = fi(FORTE_PRINT); }
        catch (Exception e) { error(e); }
        try { icons[DUMP_ICON] = fi(FORTE_DUMP); }
        catch (Exception e) { error(e); }
        try { icons[DEFAULT_ICON] = fi(FORTE_DEFAULT); }
        catch (Exception e) { error(e); }
        try { icons[PACKAGE_ICON] = fi(FORTE_PACKAGE); }
        catch (Exception e) { error(e); }
        try { icons[WATCH_ICON] = fi(FORTE_ADDWATCH); }
        catch (Exception e) { error(e); }
        try { icons[BREAKPOINTS_ICON] = cfi(FORTE_BREAKPOINTS); }
        catch (Exception e) { error(e); }
//          try { icons[VERIFIED_BREAKPOINT_ICON] = dfi(FORTE_BREAKPOINT); }
//          catch (Exception e) { error(e); }
//          try { icons[UNVERIFIED_BREAKPOINT_ICON] = dfi(FORTE_BREAKPOINT); }
//          catch (Exception e) { error(e); }
        try { icons[VERIFIED_BREAKPOINT_ICON] = cfi(FORTE_BREAKPOINT); }
        catch (Exception e) { error(e); }
        try { icons[UNVERIFIED_BREAKPOINT_ICON] = cfi(FORTE_BREAKPOINT); }
        catch (Exception e) { error(e); }        
        try { icons[MAIN_ICON] = cfi(FORTE_MAIN); }
        catch (Exception e) { error(e); }
        try { icons[THREADS_ICON] = cfi(FORTE_THREADS); }
        catch (Exception e) { error(e); }
//          try { icons[THREAD_ICON] = dfi(FORTE_THREAD_CURRENT); }
//          catch (Exception e) { error(e); }
//          try { icons[THREAD_SUSPENDED_ICON] = dfi(FORTE_THREAD_CURRENT); }
//          catch (Exception e) { error(e); }
//          try { icons[THREAD_BREAKPOINT_ICON] = dfi(FORTE_THREAD_CURRENT); }
//          catch (Exception e) { error(e); }
//          try { icons[THREAD_RUNNING_ICON] = dfi(FORTE_THREAD_RUNNING); }
//          catch (Exception e) { error(e); }
        try { icons[THREAD_ICON] = cfi(FORTE_THREAD_CURRENT); }
        catch (Exception e) { error(e); }
        try { icons[THREAD_SUSPENDED_ICON] = cfi(FORTE_THREAD_CURRENT); }
        catch (Exception e) { error(e); }
        try { icons[THREAD_BREAKPOINT_ICON] = cfi(FORTE_THREAD_CURRENT); }
        catch (Exception e) { error(e); }
        try { icons[THREAD_RUNNING_ICON] = cfi(FORTE_THREAD_RUNNING); }
        catch (Exception e) { error(e); }
        //!!! need an icon for this one, too
        try { icons[THREADGROUP_ICON] = dfi(FORTE_THREADGROUP_CURRENT); }
        catch (Exception e) { error(e); }
        try { icons[FIELD_ICON] = cfi(FORTE_VARIABLE); }
        catch (Exception e) { error(e); }
        try { icons[WATCHES_ICON] = cfi(FORTE_WATCHES); }
        catch (Exception e) { error(e); }
        try { icons[VARIABLES_ICON] = cfi(FORTE_VARIABLE); }
        catch (Exception e) { error(e); }
        try { icons[STACKFRAME_ICON] = cfi(FORTE_CALLSTACK); }
        catch (Exception e) { error(e); }
        try { icons[WATCHVAR_ICON] = cfi(FORTE_WATCH); }
        catch (Exception e) { error(e); }
        try { icons[THREADGROUP_ICON] = cfi(FORTE_THREADS); }
        catch (Exception e) { error(e); }

        try { icons[OUTPUT_ICON] = cfi(FORTE_OUTPUT); }
        catch (Exception e) { error(e); }
    }

    final static String JAVA_STRUCTURE_ICONS   =
        "com.borland.jbuilder.node.java.JavaStructureIcons";
    final static String JB_ICONS_INTERFACE     = "ICONS_INTERFACE";
    final static String JB_ICONS_CLASS         = "ICONS_CLASS";
    final static String JB_ICONS_CTR           = "ICONS_CONSTRUCTOR";
    final static String JB_ICONS_FIELD         = "ICONS_FIELD";
    final static String JB_ICONS_METHOD        = "ICONS_METHOD";
    final static String JB_PRIVATE             = "PRIVATE";
    final static String JB_PACKAGE             = "PACKAGE";
    final static String JB_PROTECTED           = "PROTECTED";
    final static String JB_PUBLIC              = "PUBLIC";
    final static String JB_STATIC              = "STATIC";

    private static Icon jbuilderIcon(String arrayName,
                              String access,
                              boolean isStatic) throws Exception {
        Class iconsClass = Class.forName(JAVA_STRUCTURE_ICONS);
        Icon[] icons = (Icon[]) iconsClass.getField(arrayName).get(null);
        int index = ((Integer) iconsClass.getField(access).get(null)).intValue();
        if (isStatic) {
            index += ((Integer) iconsClass.getField(JB_STATIC).get(null)).intValue();
        }
        return icons[index];

    }
    private static Icon jbi(String s, String t, boolean b) throws Exception {
        return jbuilderIcon(s, t, b);
    }
    public final static String JB_CONFIG = "com/borland/jbuilder/";
    public final static String JB_BROWSER_ICONS = "com.borland.primetime.ide.BrowserIcons";
    private static Icon getStaticIcon(String className, String fieldName) throws Exception {
        Class browserIcons = Class.forName(className);
        return (Icon) browserIcons.getField(fieldName).get(null);
    }
    private static Icon browserIcon(String fieldName) throws Exception {
        return getJBBrowserIcon("ICON_" + fieldName);
    }
    public static Icon getJBBrowserIcon(String fieldName) { //throws Exception {
        try {
            return getStaticIcon(JB_BROWSER_ICONS, fieldName);
        } catch (Exception e) {
            error(e);
        }
        return null;
    }   
    private static Icon bri(String fieldName) throws Exception {        
            return browserIcon(fieldName);
    }

    //new-jb-strings
    /* These can be retrieved with bri(..) */
    final static String JB_THREADUSERSUSPENDED         = "THREADUSERSUSPENDED";
    final static String JB_THREADBREAKUSERSUSPENDED    = "THREADBREAKUSERSUSPENDED";
    final static String JB_THREADBREAKBLOCKED          = "THREADBREAKBLOCKED";
    final static String JB_CLASS                       = "CLASS";
    final static String JB_ERROR                       = "ERROR";
    final static String JB_SHOWFRAME                   = "SHOWFRAME";
    final static String JB_BREAKPOINTDISABLED          = "BREAKPOINTDISABLED";
    final static String JB_BREAKPOINTINVALID           = "BREAKPOINTINVALID";
    final static String JB_BREAKPOINTVERIFIED          = "BREAKPOINTVERIFIED";
    final static String JB_BREAKPOINT                  = "BREAKPOINT";
    final static String JB_THREADBREAK                 = "THREADBREAK";
    final static String JB_WARNING                     = "WARNING";
    final static String JB_THREADDEAD                  = "THREADDEAD";
    final static String JB_THREADBLOCKED               = "THREADBLOCKED";
    final static String JB_THREADSUSPENDED             = "THREADSUSPENDED";
    final static String JB_CONSOLE                     = "CONSOLE";
    final static String JB_PRIMITIVE                   = "PRIMITIVE";
    final static String JB_THREADGROUP                 = "THREADGROUP";
    final static String JB_NULL                        = "NULL";
    final static String JB_VIEWLOADEDCLASSES           = "VIEWLOADEDCLASSES";
    final static String JB_VIEWBREAKPOINTS             = "VIEWBREAKPOINTS";
    final static String JB_ADDBREAKPOINT               = "ADDBREAKPOINT";
    final static String JB_THREAD                      = "THREAD";
    final static String JB_WATCH                       = "WATCH";
    final static String JB_ARRAY                       = "ARRAY";
    final static String JB_ADDWATCH                    = "ADDWATCH";
    final static String JB_ADDBREAK                    = "ADDBREAK";
    final static String JB_STEPOUT                     = "STEPOUT";
    final static String JB_STEPOVER                    = "STEPOVER";
    final static String JB_STEPINTO                    = "STEPINTO";
    final static String JB_PROGRAMPAUSE                = "PROGRAMPAUSE";
    final static String JB_PROGRAMRUN                  = "PROGRAMRUN";
    final static String JB_PROGRAMSTOP                 = "PROGRAMSTOP";
    final static String JB_PROGRAMRESUME               = "PROGRAMRESUME";
    final static String JB_SHOWEXECPOINT               = "SHOWEXECPOINT";
    //end-new-jb-strings


    private static void createJBuilder3Icons() throws Exception {
        createJBuilder4Icons();
    }

    private static void createJBuilder4Icons() throws Exception {
        createStandAloneIcons();
        try {
            createActualJBuilder4Icons();
        } catch (ClassNotFoundException cnfe) {
            throw new RuntimeException("Please include the JBuilder4 jar");
        }
    }
    private static void createActualJBuilder4Icons() throws Exception {

        icons[INTERFACE_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PUBLIC, false);
        icons[INTERFACE_PUBLIC_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PUBLIC, false);
        icons[INTERFACE_PACKAGE_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PACKAGE, false);
        icons[INTERFACE_PROTECTED_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PROTECTED, false);
        icons[INTERFACE_PRIVATE_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PRIVATE, false);
        icons[INTERFACE_STATIC_PUBLIC_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PUBLIC, true);
        icons[INTERFACE_STATIC_PACKAGE_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PACKAGE, true);
        icons[INTERFACE_STATIC_PROTECTED_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PROTECTED, true);
        icons[INTERFACE_STATIC_PRIVATE_ICON]
            = jbi(JB_ICONS_INTERFACE, JB_PRIVATE, true);

        icons[CLASS_ICON]
            = jbi(JB_ICONS_CLASS, JB_PUBLIC, false);
        icons[CLASS_PUBLIC_ICON]
            = jbi(JB_ICONS_CLASS, JB_PUBLIC, false);
        icons[CLASS_PACKAGE_ICON]
            = jbi(JB_ICONS_CLASS, JB_PACKAGE, false);
        icons[CLASS_PROTECTED_ICON]
            = jbi(JB_ICONS_CLASS, JB_PROTECTED, false);
        icons[CLASS_PRIVATE_ICON]
            = jbi(JB_ICONS_CLASS, JB_PRIVATE, false);
        icons[CLASS_STATIC_PUBLIC_ICON]
            = jbi(JB_ICONS_CLASS, JB_PUBLIC, true);
        icons[CLASS_STATIC_PACKAGE_ICON]
            = jbi(JB_ICONS_CLASS, JB_PACKAGE, true);
        icons[CLASS_STATIC_PROTECTED_ICON]
            = jbi(JB_ICONS_CLASS, JB_PROTECTED, true);
        icons[CLASS_STATIC_PRIVATE_ICON]
            = jbi(JB_ICONS_CLASS, JB_PRIVATE, true);

        icons[METHOD_ICON]
            = jbi(JB_ICONS_METHOD, JB_PUBLIC, false);
        icons[METHOD_PUBLIC_ICON]
            = jbi(JB_ICONS_METHOD, JB_PUBLIC, false);
        icons[METHOD_PACKAGE_ICON]
            = jbi(JB_ICONS_METHOD, JB_PACKAGE, false);
        icons[METHOD_PROTECTED_ICON]
            = jbi(JB_ICONS_METHOD, JB_PROTECTED, false);
        icons[METHOD_PRIVATE_ICON]
            = jbi(JB_ICONS_METHOD, JB_PRIVATE, false);
        icons[METHOD_STATIC_PUBLIC_ICON]
            = jbi(JB_ICONS_METHOD, JB_PUBLIC, true);
        icons[METHOD_STATIC_PACKAGE_ICON]
            = jbi(JB_ICONS_METHOD, JB_PACKAGE, true);
        icons[METHOD_STATIC_PROTECTED_ICON]
            = jbi(JB_ICONS_METHOD, JB_PROTECTED, true);
        icons[METHOD_STATIC_PRIVATE_ICON]
            = jbi(JB_ICONS_METHOD, JB_PRIVATE, true);

        icons[FIELD_ICON]
            = jbi(JB_ICONS_FIELD, JB_PUBLIC, false);
        icons[FIELD_PUBLIC_ICON]
            = jbi(JB_ICONS_FIELD, JB_PUBLIC, false);
        icons[FIELD_PACKAGE_ICON]
            = jbi(JB_ICONS_FIELD, JB_PACKAGE, false);
        icons[FIELD_PROTECTED_ICON]
            = jbi(JB_ICONS_FIELD, JB_PROTECTED, false);
        icons[FIELD_PRIVATE_ICON]
            = jbi(JB_ICONS_FIELD, JB_PRIVATE, false);
        icons[FIELD_STATIC_PUBLIC_ICON]
            = jbi(JB_ICONS_FIELD, JB_PUBLIC, true);
        icons[FIELD_STATIC_PACKAGE_ICON]
            = jbi(JB_ICONS_FIELD, JB_PACKAGE, true);
        icons[FIELD_STATIC_PROTECTED_ICON]
            = jbi(JB_ICONS_FIELD, JB_PROTECTED, true);
        icons[FIELD_STATIC_PRIVATE_ICON]
            = jbi(JB_ICONS_FIELD, JB_PRIVATE, true);

        icons[CTR_ICON]
            = jbi(JB_ICONS_CTR, JB_PUBLIC, false);
        icons[CTR_PUBLIC_ICON]
            = jbi(JB_ICONS_CTR, JB_PUBLIC, false);
        icons[CTR_PACKAGE_ICON]
            = jbi(JB_ICONS_CTR, JB_PACKAGE, false);
        icons[CTR_PROTECTED_ICON]
            = jbi(JB_ICONS_CTR, JB_PROTECTED, false);
        icons[CTR_PRIVATE_ICON]
            = jbi(JB_ICONS_CTR, JB_PRIVATE, false);
        icons[CTR_STATIC_PUBLIC_ICON]
            = jbi(JB_ICONS_CTR, JB_PUBLIC, true);
        icons[CTR_STATIC_PACKAGE_ICON]
            = jbi(JB_ICONS_CTR, JB_PACKAGE, true);
        icons[CTR_STATIC_PROTECTED_ICON]
            = jbi(JB_ICONS_CTR, JB_PROTECTED, true);
        icons[CTR_STATIC_PRIVATE_ICON]
            = jbi(JB_ICONS_CTR, JB_PRIVATE, true);

        //icons[THREADUSERSUSPENDED         bri(JB_"THREADUSERSUSPENDED";
        //icons[THREADBREAKUSERSUSPENDED    bri(JB_"THREADBREAKUSERSUSPENDED";
        //icons[_ICON] = bri(JB_THREADBREAKBLOCKED          bri(JB_"THREADBREAKBLOCKED";
        //icons[_ICON] = bri(JB_BREAKPOINTDISABLED);
        //icons[BREAKPOINT_ICON] = bri(JB_BREAKPOINT);
        //          icons[_ICON] = bri(JB_WARNING);
        //          icons[_ICON] = bri(JB_THREADDEAD);
        //      icons[_ICON] = bri(JB_THREADBLOCKED);
        //      icons[_ICON] = bri(JB_WATCH);
        //      icons[_ICON] = bri(JB_PROGRAMRUN);
        //      icons[_ICON] = bri(JB_ADDBREAK);


        //icons[CLASS_ICON] = bri(JB_CLASS);
        icons[BAD_ICON]                   = bri(JB_ERROR);
        icons[WHERE_ICON]                 = bri(JB_SHOWFRAME);
        icons[UNVERIFIED_BREAKPOINT_ICON] = bri(JB_BREAKPOINTINVALID);
        icons[VERIFIED_BREAKPOINT_ICON]   = bri(JB_BREAKPOINTVERIFIED);
        icons[THREAD_BREAKPOINT_ICON]     = bri(JB_THREADBREAK);
        icons[THREAD_SUSPENDED_ICON]      = bri(JB_THREADSUSPENDED);
        icons[BOOLEAN_ICON]               = bri(JB_PRIMITIVE);
        icons[BYTE_ICON]                  = bri(JB_PRIMITIVE);
        icons[CHAR_ICON]                  = bri(JB_PRIMITIVE);
        icons[DOUBLE_ICON]                = bri(JB_PRIMITIVE);
        icons[FLOAT_ICON]                 = bri(JB_PRIMITIVE);
        icons[INTEGER_ICON]               = bri(JB_PRIMITIVE);
        icons[LONG_ICON]                  = bri(JB_PRIMITIVE);
        icons[SHORT_ICON]                 = bri(JB_PRIMITIVE);
        icons[THREADGROUP_ICON]           = bri(JB_THREADGROUP);
        icons[NULL_OBJECT_ICON]           = bri(JB_NULL);

        // ----------------------------------------------------------------------
        // These are only in JBuilder, so we can assume the jar is loaded
        // CONSOLE
        // VIEWLOADEDCLASSES
        // VIEWBREAKPOINTS
        // ----------------------------------------------------------------------

        icons[WATCH_ICON]    = bri(JB_ADDWATCH);
        icons[STOP_ICON]     = bri(JB_ADDBREAKPOINT);
        icons[THREAD_ICON]   = bri(JB_THREAD);
        icons[ARRAY_ICON]    = bri(JB_ARRAY);
        icons[STEPUP_ICON]   = bri(JB_STEPOUT);
        icons[NEXT_ICON]     = bri(JB_STEPOVER);
        icons[STEP_ICON]     = bri(JB_STEPINTO);
        icons[SUSPEND_ICON]  = bri(JB_PROGRAMPAUSE);
        icons[QUIT_ICON]     = bri(JB_PROGRAMSTOP);
        icons[RUN_ICON]      = bri(JB_PROGRAMRESUME);
        icons[RESUME_ICON]   = bri(JB_PROGRAMRESUME);

        //new-jb-icons
        icons[THREADS_ICON]        = bri(JB_THREADGROUP);
        icons[WATCHES_ICON]        = bri(JB_WATCH);
        icons[BREAKPOINTS_ICON]    = bri(JB_VIEWBREAKPOINTS);
        icons[CLASSES_ICON]        = bri(JB_VIEWLOADEDCLASSES);
        icons[PACKAGE_ICON]        = bri(JB_PACKAGE);
        icons[STACKFRAME_ICON]     = bri(JB_SHOWEXECPOINT);
        icons[OBJECT_ICON]         = bri(JB_CLASS);
        icons[THREAD_RUNNING_ICON] = bri(JB_THREAD);
        //end-new-jb-icons
    }

    private static void createStandAloneIcons() {
        icons[BAD_ICON] = new BAD_ICON();
        icons[DEFAULT_ICON] = new DEFAULT_ICON();
        icons[THREAD_ICON] = new THREAD_ICON();
        icons[THREADGROUP_ICON] = new THREADGROUP_ICON();
        icons[ROOT_ICON] = new ROOT_ICON();
        icons[STACKFRAME_ICON] = new STACKFRAME_ICON();
        icons[THREAD_BREAKPOINT_ICON] = new THREAD_BREAKPOINT_ICON();
        icons[THREAD_SUSPENDED_ICON] = new THREAD_SUSPENDED_ICON();
        icons[THREAD_RUNNING_ICON] = new THREAD_RUNNING_ICON();
        icons[INVALID_ICON] = new INVALID_ICON();
        icons[LOCAL_VARIABLE_ICON] = new LOCAL_VARIABLE_ICON();
        icons[BOOLEAN_ICON] = new BOOLEAN_ICON();
        icons[BYTE_ICON] = new BYTE_ICON();
        icons[CHAR_ICON] = new CHAR_ICON();
        icons[DOUBLE_ICON] = new DOUBLE_ICON();
        icons[FLOAT_ICON] = new FLOAT_ICON();
        icons[INTEGER_ICON] = new INTEGER_ICON();
        icons[LONG_ICON] = new LONG_ICON();
        icons[OBJECT_ICON] = new OBJECT_ICON();
        icons[SHORT_ICON] = new SHORT_ICON();
        icons[ARRAY_ICON] = new ARRAY_ICON();
        icons[EXECUTABLE_ICON] = new EXECUTABLE_ICON();
        icons[VERIFIED_BREAKPOINT_ICON] = new VERIFIED_BREAKPOINT_ICON();
        icons[UNVERIFIED_BREAKPOINT_ICON] = new UNVERIFIED_BREAKPOINT_ICON();
        icons[NULL_OBJECT_ICON] = new NULL_OBJECT_ICON();
        icons[DOCUMENT_ICON] = new DOCUMENT_ICON();
        icons[FOLDER_ICON] = new FOLDER_ICON();
        icons[STOP_ICON] = new STOP_ICON();
        icons[CONT_ICON] = new CONT_ICON();
        icons[SUSPEND_ICON] = new SUSPEND_ICON();
        icons[RESUME_ICON] = new RESUME_ICON();
        icons[NEXT_ICON] = new NEXT_ICON();
        icons[STEPI_ICON] = new STEPI_ICON();
        icons[STEPUP_ICON] = new STEPUP_ICON();
        icons[STEP_ICON] = new STEP_ICON();
        icons[QUIT_ICON] = new QUIT_ICON();
        icons[RUN_ICON] = new RUN_ICON();
        icons[PACKAGE_ICON] = new PACKAGE_ICON();
        icons[BLANK_ICON] = new BLANK_ICON();
        icons[ADVICE_ICON] = new ADVICE_ICON();
        icons[ASPECT_ICON] = new ASPECT_ICON();
        icons[WHERE_ICON] = new WHERE_ICON();
        icons[HELP_ICON] = new HELP_ICON();
        icons[ABOUT_ICON] = new ABOUT_ICON();
        icons[PRINT_ICON] = new PRINT_ICON();
        icons[FIELDS_ICON] = new FIELDS_ICON();
        icons[DUMP_ICON] = new DUMP_ICON();
        icons[EVALUATE_ICON] = new EVALUATE_ICON();
        icons[LOCALS_ICON] = new LOCALS_ICON();
        icons[USE_ICON] = new USE_ICON();
        icons[CLEAR_ICON] = new CLEAR_ICON();
        icons[DISCONNECT_ICON] = new DISCONNECT_ICON();
        icons[CATCH_ICON] = new CATCH_ICON();

        //new-defaults
        icons[WATCH_ICON] = new BAD_ICON();
        icons[MAIN_ICON] = new BAD_ICON();
        icons[BREAKPOINTS_ICON] = new ROOT_ICON();
        icons[THREADS_ICON] = new ROOT_ICON();
        icons[WATCHES_ICON] =  new ROOT_ICON();
        icons[INITIALIZER_ICON] = new METHOD_ICON();
        icons[VARIABLES_ICON] = new ROOT_ICON();
        icons[WATCHVAR_ICON] = new FIELDS_ICON();
        icons[CLASSES_ICON] = new PACKAGE_ICON();
        //end-new-defaults
        
        icons[INTERFACE_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_PUBLIC_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_PACKAGE_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_PROTECTED_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_PRIVATE_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_STATIC_PUBLIC_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_STATIC_PACKAGE_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_STATIC_PROTECTED_ICON] = new INTERFACE_ICON();
        icons[INTERFACE_STATIC_PRIVATE_ICON] = new INTERFACE_ICON();

        icons[CLASS_ICON] = new CLASS_ICON();
        icons[CLASS_PUBLIC_ICON] = new CLASS_ICON();
        icons[CLASS_PACKAGE_ICON] = new CLASS_ICON();
        icons[CLASS_PROTECTED_ICON] = new CLASS_ICON();
        icons[CLASS_PRIVATE_ICON] = new CLASS_ICON();
        icons[CLASS_STATIC_PUBLIC_ICON] = new CLASS_ICON();
        icons[CLASS_STATIC_PACKAGE_ICON] = new CLASS_ICON();
        icons[CLASS_STATIC_PROTECTED_ICON] = new CLASS_ICON();
        icons[CLASS_STATIC_PRIVATE_ICON] = new CLASS_ICON();

        icons[METHOD_ICON] = new METHOD_ICON();
        icons[METHOD_PUBLIC_ICON] = new METHOD_ICON();
        icons[METHOD_PACKAGE_ICON] = new METHOD_ICON();
        icons[METHOD_PROTECTED_ICON] = new METHOD_ICON();
        icons[METHOD_PRIVATE_ICON] = new METHOD_ICON();
        icons[METHOD_STATIC_PUBLIC_ICON] = new METHOD_ICON();
        icons[METHOD_STATIC_PACKAGE_ICON] = new METHOD_ICON();
        icons[METHOD_STATIC_PROTECTED_ICON] = new METHOD_ICON();
        icons[METHOD_STATIC_PRIVATE_ICON] = new METHOD_ICON();

        icons[FIELD_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_PUBLIC_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_PACKAGE_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_PROTECTED_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_PRIVATE_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_STATIC_PUBLIC_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_STATIC_PACKAGE_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_STATIC_PROTECTED_ICON] = new LOCAL_VARIABLE_ICON();
        icons[FIELD_STATIC_PRIVATE_ICON] = new LOCAL_VARIABLE_ICON();

        icons[CTR_ICON] = new METHOD_ICON();
        icons[CTR_PUBLIC_ICON] = new METHOD_ICON();
        icons[CTR_PACKAGE_ICON] = new METHOD_ICON();
        icons[CTR_PROTECTED_ICON] = new METHOD_ICON();
        icons[CTR_PRIVATE_ICON] = new METHOD_ICON();
        icons[CTR_STATIC_PUBLIC_ICON] = new METHOD_ICON();
        icons[CTR_STATIC_PACKAGE_ICON] = new METHOD_ICON();
        icons[CTR_STATIC_PROTECTED_ICON] = new METHOD_ICON();
        icons[CTR_STATIC_PRIVATE_ICON] = new METHOD_ICON();

        NO_ICON = icons[DEFAULT_ICON];
    }

    public static String d() {
        return "AspectJ Icons [" + Modes.getMode() + "]";
    }

    public static Icon NO_ICON;;// = icons[DEFAULT_ICON];

    public static Icon getIcon(AJTreeNode node) {
        return getIcon(node.getType());
    }

    public static Icon getIcon(int type) {
        if (type < 0) {
            throw new ArrayIndexOutOfBoundsException
                ("icon type out of range: " + type + " < 0");
        }
        if (type >= icons.length) {
            throw new ArrayIndexOutOfBoundsException
                ("icon type out of range: " +
                 type + " > " + (icons.length-1));
        }
        return icons[type];
    }


    // Other classes here

    // Main here

	public static void main(String[] args) {
        new AJIconsTest().go(icons);
    }
}


