/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.gui;

import org.aspectj.debugger.base.*;

import com.sun.jdi.InvalidTypeException;
import com.sun.jdi.ClassNotLoadedException;
import com.sun.jdi.LocalVariable;
import com.sun.jdi.ReferenceType;
import com.sun.jdi.StackFrame;
import com.sun.jdi.ThreadReference;
import com.sun.jdi.Type;
import com.sun.jdi.Value;

public class AJLocalVariableValueGetter implements AJValueGetter {

    public /*private*/ LocalVariable   local   = null;
    public /*private*/ StackFrame      frame   = null;

    public AJLocalVariableValueGetter(LocalVariable local, StackFrame frame) {
        this.local  = local;
        this.frame  = frame;
    }

    public Value getValue() {
        return frame.getValue(local);
    }

    public Value getValue(String s) {
        return frame.getValue(local);
    }

    public void setValue(Value v) throws ClassNotLoadedException,
                                         InvalidTypeException {
        frame.setValue(local, v);
    }

    public ThreadReference getThread() throws ClassNotLoadedException {
        return frame.thread();
    }

    public String getName() {
        return local.name();
    }

    public Type getTypeRef()  throws ClassNotLoadedException {
        return local.type();
    }

    public String getTypeName() {
        return local.typeName();
    }

    public ReferenceType getDeclaringClass() {
        return null;
    }
}
