/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.gui;

import org.aspectj.debugger.base.*;

import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import javax.swing.SwingUtilities;
import javax.swing.tree.TreePath;
import com.sun.jdi.*;

public class AJThreadGroupTreeMouseListener implements MouseListener {

    private AJTree tree = null;

    public AJThreadGroupTreeMouseListener(AJTree tree) {
        this.tree = tree;
    }

    public void mouseClicked(MouseEvent e) {
        int row = tree.getRowForLocation(e.getX(), e.getY());
        TreePath path = tree.getPathForLocation(e.getX(), e.getY());
        if (row == -1) {
            return;
        }
        AJTreeNode node = (AJTreeNode) path.getLastPathComponent();
        if (SwingUtilities.isLeftMouseButton(e)) {
            node.leftMouseButton(e);
        } else if (SwingUtilities.isMiddleMouseButton(e)) {
            node.middleMouseButton(e);
        } else if (SwingUtilities.isRightMouseButton(e)) {
            node.rightMouseButton(e);
        }
    }

    public void mousePressed(MouseEvent e) {
        //TODO: Implement this java.awt.event.MouseListener method
    }

    public void mouseReleased(MouseEvent e) {
        //TODO: Implement this java.awt.event.MouseListener method
    }

    public void mouseEntered(MouseEvent e) {
        //TODO: Implement this java.awt.event.MouseListener method
    }

    public void mouseExited(MouseEvent e) {
        //TODO: Implement this java.awt.event.MouseListener method
    }
}