/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
*
* This file is part of the debugger and core tools for the AspectJ(tm)
* programming language; see http://aspectj.org
*
* The contents of this file are subject to the Mozilla Public License
* Version 1.1 (the "License"); you may not use this file except in
* compliance with the License. You may obtain a copy of the License at
* either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
*
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is AspectJ.
*
* The Initial Developer of the Original Code is Xerox Corporation. Portions
* created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
* All Rights Reserved.
*/
package org.aspectj.debugger.gui;

import org.aspectj.tools.ide.*;
import java.util.*;

public class AdvisableMethodNode extends MethodNode {
    public AdvisableMethodNode(Declaration methodDec) {
        super(new AJCMethodHelper(methodDec));
    }

    public List getAdviceStrings() {
        List adviceStrings = new Vector();
        if (children == null) return adviceStrings;
        Iterator iter = children.iterator();
        while (iter.hasNext()) {
            adviceStrings.add(((AdviceNode) iter.next()).getBreakpoint());
        }
        return adviceStrings;
    }
}
