/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.gui;

import org.aspectj.debugger.base.*;
import org.aspectj.util.gui.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.event.*;

import com.sun.jdi.*;

//  aspect ClassInsightAspectSupport {

//      /** The static list of classes. */
//      static Vector classes           = null;

//      /** The current class index in classes. */
//      static int index                = 0;

//      /**
//       * Move <i>up</i> one slot in the <code>classes</code> history and
//       * insert that class into the text field.
//       */
//      static void superUp() {
//          lazyInit();
//          if (--index < 0) {
//              index = classes.size() - 1;
//          }
//      }

//      /**
//       * Move <i>down</i> one slot in the <code>classes</code> history and
//       * insert that class into the text field.
//       */
//      static void superDown() {
//          lazyInit();
//          index = (index + 1) % classes.size();
//      }

//      static String currentClass() {
//          return classes.get(index) + "";
//      }

//      /* -------------------------------------------------------
//       * Getting Classes
//       * -------------------------------------------------------
//       */

//      /**
//       * The pointcut <code>PointCuts.getClass(Object)</code> defines
//       * all instances in the execution in the program where the user
//       * can enter a class.  Therefore, whenever this occurs, we want
//       * to grab this class and put it in the global list
//       * <code>classes</code>.
//       */
//      static around(Object clazz) returns void: PointCuts.getClass(clazz) {
//          thisJoinPoint.runNext(clazz);
//          lazyInit();
//          String classID = clazz + "";
//          add(classID);
//      }

//      /**
//       * Add a class to the list of <code>classes</code>.  If it already exists,
//       * then remove the other entry and put this one at the top.
//       */
//      static void add(String classID) {
//          classID = translate(classID);
//          if (classes.contains(classID)) {
//              classes.remove(classID);
//          } else {
//              index++;
//          }
//          classes.add(classID);
//      }

//      static String translate(String classWithPossibleGarbageCharacters) {
//          char[] chars = classWithPossibleGarbageCharacters.toCharArray();
//          for (int i = 0; i < chars.length; i++) {
//              if (!Character.isJavaIdentifierPart(chars[i])) {
//                  chars[i] = '.';
//              }
//          }
//          return new String(chars);
//      }


//      /**
//       * We also want to get classes named after files, so we will advise
//       * the pointcut <code>PointCuts.getSource(Object)</code> and strip off
//       * the '.java' ending.
//       */
//      static around(Object source) returns void: PointCuts.getSource(source) {
//          thisJoinPoint.runNext(source);
//          lazyInit();
//          String classID = source + "";
//          int ijava = classID.lastIndexOf(".java");
//          if (ijava != -1) {
//              classID = classID.substring(0, ijava);
//          }
//          add(classID);
//      }

//      /**
//       * Allow a blank space in the class list, so the user can scroll
//       * to empty instead of having to delete  if s/he wants to enter a
//       * new class and has been scrolling.
//       */
//      static void lazyInit() {
//          if (classes == null) {
//              classes = new Vector();
//              classes.add("");
//          }
//      }

//      /**
//       * Returns the lastest class used.
//       */
//      static String latest() {
//          lazyInit();
//          return classes.get(classes.size() - 1) + "";
//      }
//  }

//  /**
//   * This aspect provides contextual information to text boxes
//   * expecting class information as input.
//   */
//  aspect ClassInsightAspect extends ClassInsightAspectSupport
//      of eachobject(instanceof(ClassTextField)) {

//      /** The text field to which this aspect is attached. */
//      private ClassTextField field    = null;

//      /* -------------------------------------------------------
//       * Insight
//       * -------------------------------------------------------
//       */

//      /**
//       * When a <code>ClassTextField</code> is created, make it this
//       * aspect's <code>field</code>.
//       */
//      pointcut ctr(ClassTextField f): receptions(new(..)) && instanceof(f);
//      after(ClassTextField f) returning (): ctr(f) {
//          field = f;
//          prepare(field);
//          index = 0;
//      }

//      /**
//       * Prepare any component to respond accordingly to up and down
//       * buttons presses, and mouse clicks.
//       */
//      void prepare(JComponent c) {
//          reg(c, new UpAction(),   KeyEvent.VK_UP,   0);
//          reg(c, new DownAction(), KeyEvent.VK_DOWN, 0);
//          c.addMouseListener(new MouseAdapter() {
//              public void mouseClicked(MouseEvent e) {
//                  if (e.getClickCount() == 2) {
//                      showAllClasses();
//                  } else if (SwingUtilities.isRightMouseButton(e)) {
//                      showHistory();
//                  }
//          }});
//      }

//      void reg(JComponent c, Action a, int key, int mods) {
//          FocusAspect.reg(c, a, key, mods, JComponent.WHEN_FOCUSED);
//      }

//      /**
//       * The action to perform upon an <i>up</i> button press.
//       */
//      private class UpAction extends AbstractAction {
//          public void actionPerformed(ActionEvent e) {
//              up();
//          }
//      }

//      /**
//       * The action to perform upon <i>down</i> button press.
//       */
//      private class DownAction extends AbstractAction {
//          public void actionPerformed(ActionEvent e) {
//              down();
//          }
//      }

//      /**
//       * Move <i>up</i> one slot in the <code>classes</code> history and
//       * insert that class into the text field.
//       */
//      private void up() {
//          superUp();
//          field.setText(currentClass());
//      }

//      /**
//       * Move <i>down</i> one slot in the <code>classes</code> history and
//       * insert that class into the text field.
//       */
//      private void down() {
//          superDown();
//          field.setText(currentClass());
//      }

//      /**
//       * Create a pop-up menu in which to display the classes
//       * previously entered by the user.
//       */
//      void showHistory() {
//          AJPopupMenu menu = new AJPopupMenu("Classes", classes) {
//              public void doSomething(Object o) {
//                  setClassText(o + "");
//          }};
//          field.transferFocus();
//          menu.show(field, 10, 10);
//          menu.requestFocus();
//      }

//      /**
//       * Create a pop-up menu in which to display all classes currently
//       * loaded by the VM.
//       */
//      void showAllClasses() {
//          Vector vec = new Vector();
//          Iterator iter = null;
//          try {
//              iter = ComponentRepository.vm().allClasses().iterator();
//          } catch (NoVMException e) {
//              return;
//          }

//          while (iter.hasNext()) {
//              vec.add(((ReferenceType) iter.next()).name());
//          }
//          AJPopupMenu menu = new AJPopupMenu("All Classes", vec) {
//              public void doSomething(Object o) {
//                  setClassText(o + "");
//          }};
//          field.transferFocus();
//          menu.show(field, 10, 10);
//          menu.requestFocus();
//      }

//      /**
//       * Method to set the text in <code>field</code>.
//       */
//      void setClassText(String clazz) {
//          field.setText(clazz);
//      }
//  }

//  aspect SourceInsightAspectSupport {

//      /** The static list of sources. */
//      static Vector sources           = null;

//      /** The current source index in sources. */
//      static int index                = 0;

//      /**
//       * Move <i>up</i> one slot in the <code>sources</code> history and
//       * insert that source into the text field.
//       */
//      static void superUp() {
//          lazyInit();
//          if (--index < 0) {
//              index = sources.size() - 1;
//          }
//      }

//      /**
//       * Move <i>down</i> one slot in the <code>sources</code> history and
//       * insert that source into the text field.
//       */
//      static void superDown() {
//          lazyInit();
//          index = (index + 1) % sources.size();
//      }

//      static String currentSource() {
//          return sources.get(index) + "";
//      }

//      /* -------------------------------------------------------
//       * Getting Sources
//       * -------------------------------------------------------
//       */

//      /**
//       * The pointcut <code>PointCuts.getClass(Object)</code> defines
//       * all instances in the execution in the program where the user
//       * can enter a class.  Therefore, whenever this occurs, we want
//       * to grab this class and put it in the global list
//       * <code>classes</code>.
//       */
//      static around(Object source) returns void: PointCuts.getSource(source) {
//          thisJoinPoint.runNext(source);
//          lazyInit();
//          String sourceID = AJLineMapper.removeRoot(source + "");
//          add(sourceID);
//      }

//      /**
//       * Add a class to the list of <code>sources</code>.  If it already exists,
//       * then remove the other entry and put this one at the top.
//       */
//      static void add(String sourceID) {
//          if (sources.contains(sourceID)) {
//              sources.remove(sourceID);
//          } else {
//              index++;
//          }
//          sources.add(sourceID);
//      }

//      /**
//       * We will also try to get source from classes using the pointcut
//       * <code>PointCuts.getSource(Object)</code> by trying to append a
//       * '.java' ending and seeing if the file exists.
//       */
//      static around(Object clazz) returns void: PointCuts.getClass(clazz) {
//          thisJoinPoint.runNext(clazz);
//          lazyInit();
//          String sourceID = clazz + ".java";
//          String fullSource = AJLineMapper.getFullFileNameFromFile(sourceID, false);
//          try {
//              File file = new File(fullSource);
//              if (file == null || !file.exists()) {
//                  return;
//              }
//          } catch (Exception e) {
//          }
//          String strippedSource = AJLineMapper.removeRoot(fullSource);
//          add(strippedSource);
//      }

//      /**
//       * Allow a blank space in the class list, so the user can scroll
//       * to empty instead of having to delete  if s/he wants to enter a
//       * new class and has been scrolling.
//       */
//      static void lazyInit() {
//          if (sources == null) {
//              sources = new Vector();
//              sources.add("");
//          }
//      }

//      /**
//       * Returns the latest source file.
//       */
//      static String latest() {
//          lazyInit();
//          return sources.get(sources.size() - 1) + "";    }
//  }

//  /**
//   * This aspect provides contextual information to text boxes
//   * expecting source information as input.
//   */
//  aspect SourceInsightAspect
//          extends SourceInsightAspectSupport
//          of eachobject(instanceof(SourceTextField)) {


//      /** The text field to which this aspect is attached. */
//      private SourceTextField field   = null;

//      /* -------------------------------------------------------
//       * Insight
//       * -------------------------------------------------------
//       */

//      /**
//       * When a <code>ClassTextField</code> is created, make it this
//       * aspect's <code>field</code>.
//       */
//      pointcut ctr(SourceTextField f): receptions(new(..)) && instanceof(f);
//      after(SourceTextField f) returning (): ctr(f) {
//          field = f;
//          prepare(field);
//          index = 0;
//      }

//      /**
//       * Prepare any component to respond accordingly to up and down
//       * buttons presses, and mouse clicks.
//       */
//      void prepare(JComponent c) {
//          reg(c, new UpAction(),   KeyEvent.VK_UP,   0);
//          reg(c, new DownAction(), KeyEvent.VK_DOWN, 0);
//          c.addMouseListener(new MouseAdapter() {
//              public void mouseClicked(MouseEvent e) {
//                  if (e.getClickCount() == 2) {
//                      showAllSources();
//                  } else if (SwingUtilities.isRightMouseButton(e)) {
//                      showHistory();
//                  }
//          }});
//      }

//      void reg(JComponent c, Action a, int key, int mods) {
//          FocusAspect.reg(c, a, key, mods, JComponent.WHEN_FOCUSED);
//      }

//      /**
//       * The action to perform upon an <i>up</i> button press.
//       */
//      private class UpAction extends AbstractAction {
//          public void actionPerformed(ActionEvent e) {
//              up();
//          }
//      }

//      /**
//       * The action to perform upon <i>down</i> button press.
//       */
//      private class DownAction extends AbstractAction {
//          public void actionPerformed(ActionEvent e) {
//              down();
//          }
//      }

//      /**
//       * Move <i>up</i> one slot in the <code>sources</code> history and
//       * insert that source into the text field.
//       */
//      private void up() {
//          superUp();
//          field.setText(currentSource());
//      }

//      /**
//       * Move <i>down</i> one slot in the <code>sources</code> history and
//       * insert that source into the text field.
//       */
//      private void down() {
//          superDown();
//          field.setText(currentSource());
//      }

//      /**
//       * Create a pop-up menu in which to display the classes
//       * previously entered by the user.
//       */
//      void showHistory() {
//          AJPopupMenu menu = new AJPopupMenu("Sources", sources) {
//              public void doSomething(Object o) {
//                  setSourceText(o + "");
//          }};
//          field.transferFocus();
//          menu.show(field, 10, 10);
//          menu.requestFocus();
//      }

//      /**
//       * Create a pop-up menu in which to display all classes currently
//       * loaded by the VM.
//       */
//      void showAllSources() {
//          Vector vec = new Vector();
//          String sourcePath = ComponentRepository.getSourcePane().getSourcePath() + "";
//          String[] files = null;
//          try {
//              File file = new File(sourcePath);
//              if (!file.isDirectory()) {
//                  return;
//              }
//              FilenameFilter filter = new FilenameFilter() {
//                  public boolean accept(File dir, String name) {
//                      if (name.endsWith(".java")) {
//                          return true;
//                      }
//                      return false;
//                  }
//              };
//              files = file.list(filter);
//          } catch (Exception e) {
//              return;
//          }

//          if (files == null || files.length == 0) {
//              return;
//          }
//          for (int i = 0; i < files.length; i++) {
//              vec.add(files[i]);
//          }

//          AJPopupMenu menu = new AJPopupMenu("All Sources", vec) {
//              public void doSomething(Object o) {
//                  setSourceText(o + "");
//          }};
//          field.transferFocus();
//          menu.show(field, 10, 10);
//          menu.requestFocus();
//      }

//      /**
//       * Method to set the text in <code>field</code>.
//       */
//      void setSourceText(String clazz) {
//          field.setText(clazz);
//      }
//  }

//  /**
//   * This aspect provides contextual information to text boxes
//   * expecting class information as input.
//   */
//  aspect MethodInsightAspect of eachobject(instanceof(BreakpointDialog)) {

//      /** The field that will receive new key bindings. */
//      private JTextField methodText  = null;

//      /** The field from which class context is gathered. */
//      private JTextField classText    = null;

//      /** The field to which parameters are placed. */
//      private JTextField paramsText       = null;

//      /* -------------------------------------------------------
//       * Insight
//       * -------------------------------------------------------
//       */

//      /**
//       * Capture the trio of text fields are created in breakpoint dialog.
//       */
//      pointcut ctr(BreakpointDialog bp):
//          receptions(new(..)) && instanceof(bp);
//      after(BreakpointDialog bp) returning (): ctr(bp) {
//          classText = bp.classText2;
//          methodText = bp.methodText;
//          paramsText = bp.paramsText;
//          prepare(methodText);
//      }

//      /**
//       * Add keybinds to a component.
//       */
//      void prepare(JComponent c) {
//          reg(c, new UpAction(),   KeyEvent.VK_UP,   0);
//          reg(c, new DownAction(), KeyEvent.VK_DOWN, 0);
//          c.addMouseListener(new MouseAdapter() {
//              public void mouseClicked(MouseEvent e) {
//                  if (SwingUtilities.isRightMouseButton(e)) {
//                      down();
//                  }
//          }});
//      }

//      void reg(JComponent c, Action a, int key, int mods) {
//          FocusAspect.reg(c, a, key, mods, JComponent.WHEN_FOCUSED);
//      }

//      private class UpAction extends AbstractAction {
//          public void actionPerformed(ActionEvent e) {
//              up();
//          }
//      }

//      private class DownAction extends AbstractAction {
//          public void actionPerformed(ActionEvent e) {
//              down();
//          }
//      }

//      /**
//       * The action to perform upon an <i>up</i> button press.
//       */
//      void up() {
//          String clazz = classText.getText();
//          String start = methodText.getText();
//          ReferenceType refType = null;
//          try {
//              refType = ComponentRepository.getAJDebugger().getReferenceTypeFromToken(clazz);
//          } catch (NoVMException e) {
//              return;
//          }
//          if (refType == null) {
//              return;
//          }
//          List methods = refType.methodsByName(start);
//          showMenu(methods, clazz);
//      }

//      /**
//       * The action to perform upon a <i>down</i> button press.
//       */
//      void down() {
//          String clazz = classText.getText();
//          ReferenceType refType = null;
//          try {
//            //refType = Env.getReferenceTypeFromToken(clazz);
//            refType = ComponentRepository.getAJDebugger().getReferenceTypeFromToken(clazz);
//          } catch (NoVMException e) {
//              return;
//          }
//          if (refType == null) {
//              return;
//          }
//          List methods = refType.methods();
//          showMenu(methods, clazz);
//      }

//      /**
//       * Create a pop-up menu in which to display the methods available
//       * in the currently-selected class.
//       */
//      void showMenu(List methods, String clazz) {
//          Iterator iter = methods.iterator();
//          Vector vec = new Vector();
//          while (iter.hasNext()) {
//              Method method = (Method) iter.next();
//              vec.add(new FormattedMethod(method));
//          }
//          AJPopupMenu menu = new AJPopupMenu("Methods for " + clazz, vec) {
//              public void doSomething(Object o) {
//                  Method m = ((FormattedMethod) o).method;
//                  //
//                  // Had to use String version because AJC will only allow
//                  // one version of stripTypeFomMethod
//                  //
//                  String meth = AJUtil.stripTypeFromMethod(m + "");
//                  String params = AJUtil.getParamsFromMethod(m);
//                  setMethodText(meth, params);
//          }};
//          methodText.transferFocus();
//          menu.show(methodText, 10, 10);
//          menu.requestFocus();
//      }

//      /**
//       * A convenience class used to display methods in the method list.
//       */
//      private class FormattedMethod {
//          Method method = null;
//          FormattedMethod(Method method) {
//              this.method = method;
//          }
//          public String toString() {
//              //
//              // Had to use String version because AJC will only allow
//              // one version of stripTypeFomMethod
//              //
//              return AJUtil.stripTypeFromMethod(method + "");
//          }
//      }

//      /**
//       * Method to set the method and params for a given
//       * <code>method</code> and <code>params</code>.
//       */
//      private void setMethodText(String method, String params) {
//          int iParen = method.indexOf("(");
//          if (iParen != -1) {
//              method = method.substring(0, iParen);
//          }
//          methodText.setText(method);
//          paramsText.setText(params);
//      }
//  }

abstract class AJPopupMenu extends JPopupMenu
  implements ListSelectionListener,
             AdjustmentListener
{

    private  boolean scrolling = false;
    private    JList list;
    private   Object selection;

    public AJPopupMenu(String s, Vector v) {
        this(s, v.toArray());
    }

    public AJPopupMenu(String s, Object[] items) {
        super(s);

        list = new JList(items);
        list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list.addListSelectionListener(this);

        JScrollPane scroll = new JScrollPane(list);
        scroll.getVerticalScrollBar().addAdjustmentListener(this);
        add(scroll);
    }

    public abstract void doSomething(Object s);

    public Object getSelection() {
        return selection;
    }

    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting()) {
            int index = list.getMaxSelectionIndex();
            selection = list.getModel().getElementAt(index);
            scrolling = false;
        } else {
            doSomething(selection);
            setVisible(false);
        }
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
        scrolling = true;
    }
}

class ClassTextField extends JTextField {
    ClassTextField(int i) {
        super(i);
    }
}

class SourceTextField extends JTextField {
    SourceTextField(int i) {
        super(i);
    }
}

public /*abstract*/ class BreakpointDialog extends CenteredJDialog {

    public /*abstract*/ boolean isSetting() { return true; }


    static final int CLASS1_COLS        = 20;
    static final int LINE_COLS          =  5;

    final String job                    = isSetting() ? "Set" : "Clear";

    String      classMethodMsg          = job + " a method breakpoint";
    ClassTextField  classText1              = new ClassTextField(CLASS1_COLS);
    JTextField  lineText                = new JTextField(LINE_COLS);

    static final int CLASS2_COLS        = 20;
    static final int METHOD_COLS        = 20;
    static final int PARAMS_COLS        = 42;

    String      classLineMsg            = job + " a class-line breakpoint";
    JTextField  classText2              = new JTextField(CLASS2_COLS);
    JTextField  methodText              = new JTextField(METHOD_COLS);
    JTextField  paramsText              = new JTextField(PARAMS_COLS);

    static final int SOURCE_COLS        = 20;

    String          sourceLineMsg       = job + " a source-line breakpoint";
    SourceTextField sourceText          = new SourceTextField(SOURCE_COLS);
    JTextField      lineText2           = new JTextField(LINE_COLS);

    public BreakpointDialog(Frame frame) {
        super(frame, "", true);
        setTitle(job + " a Breakpoint");

        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
        mainPanel.add(classMethodPanel());
        mainPanel.add(classLinePanel());
        mainPanel.add(sourceLinePanel());
        mainPanel.add(buttonPanel());

        setResizable(false);
        setContentPane(mainPanel);
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    }

    JPanel classLinePanel() {
        KeyListener potato = new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    setClassLineBreakpoint();
                }
            }};
        classText1.addKeyListener(potato);
        lineText.addKeyListener(potato);

        JPanel classTextPanel1 = new JPanel();
        classTextPanel1.setLayout(new BoxLayout(classTextPanel1, BoxLayout.Y_AXIS));
        classTextPanel1.add(Box.createHorizontalGlue());
        classTextPanel1.add(classText1);
        classTextPanel1.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Class"));
        JPanel lineTextPanel = new JPanel();
        lineTextPanel.setLayout(new BoxLayout(lineTextPanel, BoxLayout.Y_AXIS));
        lineTextPanel.add(Box.createHorizontalGlue());
        lineTextPanel.add(lineText);
        lineTextPanel.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Line"));
        JPanel mainPanel1 = new JPanel();
        mainPanel1.setLayout(new BoxLayout(mainPanel1, BoxLayout.X_AXIS));
        mainPanel1.add(classTextPanel1);
        mainPanel1.add(lineTextPanel);
        JButton jobButton = null;
        if (isSetting()) {
            jobButton = new JButton("Set");
            jobButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    setClassLineBreakpoint();
                }});
        } else {
            jobButton = new JButton("Clear");
            jobButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    classLineClear();
                }});
        }
        JPanel buttonPanel1 = new JPanel();
        buttonPanel1.setLayout(new BoxLayout(buttonPanel1, BoxLayout.X_AXIS));
        buttonPanel1.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        buttonPanel1.add(Box.createHorizontalGlue());
        buttonPanel1.add(jobButton);
        JPanel classLinePanel = new JPanel();
        classLinePanel.setLayout(new BorderLayout());
        classLinePanel.add(mainPanel1, BorderLayout.CENTER);
        classLinePanel.add(buttonPanel1, BorderLayout.SOUTH);
        classLinePanel.setBorder(BorderFactory.createTitledBorder(classLineMsg));
        return classLinePanel;
    }

    JPanel classMethodPanel() {
        KeyListener george = new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    setClassMethodBreakpoint();
                }
            }};
        classText2.addKeyListener(george);
        methodText.addKeyListener(george);
        paramsText.addKeyListener(george);

        JPanel classTextPanel2 = new JPanel();
        classTextPanel2.setLayout(new BoxLayout(classTextPanel2, BoxLayout.Y_AXIS));
        classTextPanel2.add(Box.createHorizontalGlue());
        classTextPanel2.add(classText2);
        classTextPanel2.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Class"));
        JPanel methodTextPanel = new JPanel();
        methodTextPanel.setLayout(new BoxLayout(methodTextPanel, BoxLayout.Y_AXIS));
        methodTextPanel.add(Box.createHorizontalGlue());
        methodTextPanel.add(methodText);
        methodTextPanel.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Method"));
        JPanel topPanel = new JPanel();
        topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.X_AXIS));
        topPanel.add(classTextPanel2);
        topPanel.add(methodTextPanel);

        JPanel paramsTextPanel = new JPanel();
        paramsTextPanel.setLayout(new BoxLayout(paramsTextPanel, BoxLayout.Y_AXIS));
        paramsTextPanel.add(Box.createHorizontalGlue());
        paramsTextPanel.add(paramsText);
        paramsTextPanel.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Parameters"));
        JPanel bottomPanel = new JPanel();
        bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.X_AXIS));
        bottomPanel.add(paramsTextPanel);
        JPanel middlePanel = new JPanel();
        middlePanel.setLayout(new BoxLayout(middlePanel, BoxLayout.Y_AXIS));
        middlePanel.add(topPanel);
        middlePanel.add(bottomPanel);
        JButton jobButton = null;
        if (isSetting()) {
            jobButton = new JButton("Set");
            jobButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    setClassMethodBreakpoint();
                }});
        } else {
            jobButton = new JButton("Clear");
            jobButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    classMethodClear();
                }});
        }
        JPanel buttonPanel2 = new JPanel();
        buttonPanel2.setLayout(new BoxLayout(buttonPanel2, BoxLayout.X_AXIS));
        buttonPanel2.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        buttonPanel2.add(Box.createHorizontalGlue());
        buttonPanel2.add(jobButton);
        JPanel classMethodPanel = new JPanel();
        classMethodPanel.setLayout(new BorderLayout());
        classMethodPanel.add(middlePanel, BorderLayout.CENTER);
        classMethodPanel.add(buttonPanel2, BorderLayout.SOUTH);
        classMethodPanel.setBorder(BorderFactory.createTitledBorder(classMethodMsg));
        return classMethodPanel;
    }

    JPanel sourceLinePanel() {
        KeyListener potato = new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    setSourceLineBreakpoint();
                }
            }};
        sourceText.addKeyListener(potato);
        lineText2.addKeyListener(potato);

        JPanel classTextPanel1 = new JPanel();
        classTextPanel1.setLayout(new BoxLayout(classTextPanel1, BoxLayout.Y_AXIS));
        classTextPanel1.add(Box.createHorizontalGlue());
        classTextPanel1.add(sourceText);
        classTextPanel1.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Source"));
        JPanel lineTextPanel = new JPanel();
        lineTextPanel.setLayout(new BoxLayout(lineTextPanel, BoxLayout.Y_AXIS));
        lineTextPanel.add(Box.createHorizontalGlue());
        lineTextPanel.add(lineText2);
        lineTextPanel.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createEmptyBorder(0,0,0,0), "Line"));
        JPanel mainPanel1 = new JPanel();
        mainPanel1.setLayout(new BoxLayout(mainPanel1, BoxLayout.X_AXIS));
        mainPanel1.add(classTextPanel1);
        mainPanel1.add(lineTextPanel);
        JButton jobButton = null;
        if (isSetting()) {
            jobButton = new JButton("Set");
            jobButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    setSourceLineBreakpoint();
                }});
        } else {
            jobButton = new JButton("Clear");
            jobButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    sourceLineClear();
                }});
        }
        JPanel buttonPanel1 = new JPanel();
        buttonPanel1.setLayout(new BoxLayout(buttonPanel1, BoxLayout.X_AXIS));
        buttonPanel1.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        buttonPanel1.add(Box.createHorizontalGlue());
        buttonPanel1.add(jobButton);
        JPanel sourceLinePanel = new JPanel();
        sourceLinePanel.setLayout(new BorderLayout());
        sourceLinePanel.add(mainPanel1, BorderLayout.CENTER);
        sourceLinePanel.add(buttonPanel1, BorderLayout.SOUTH);
        sourceLinePanel.setBorder(BorderFactory.createTitledBorder(sourceLineMsg));
        return sourceLinePanel;
    }

    JPanel buttonPanel() {
        JButton cancelButton = new JButton("Cancel");
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancel();
            }});
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
        buttonPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        buttonPanel.add(Box.createHorizontalGlue());
        buttonPanel.add(cancelButton);
        return buttonPanel;
    }


    public BreakpointDialog() {
        this(null);
    }

    public void show() {
        pack();
        super.show();
    }

    String getClass1() {
        return classText1.getText();
    }

    String getClass2() {
        return classText2.getText();
    }

    private void setClassLineBreakpoint() {
        String className = classText1.getText();
        int line = -1;
        try {
            line = Integer.parseInt(lineText.getText());
        } catch (NumberFormatException e) {
            AJUtil.warn("The line field must contain a number");
            return;
        }
        String cmd = "stop at " + className + ":" + line;
        ComponentRepository.getCommandLine().executeCommand(cmd);
        hide();
    }

    private void classLineClear() {
        classText1.setText("");
        lineText.setText("");
    }

    private void setSourceLineBreakpoint() {
        String sourceName = sourceText.getText();
        int line = -1;
        try {
            line = Integer.parseInt(lineText2.getText());
        } catch (NumberFormatException e) {
            AJUtil.warn("The line field must contain a number");
            return;
        }
        String cmd = "stop on " + sourceName + ":" + line;
        ComponentRepository.getCommandLine().executeCommand(cmd);
        hide();
    }

    private void sourceLineClear() {
        sourceText.setText("");
        lineText2.setText("");
    }

    private void setClassMethodBreakpoint() {
        String cmd = "stop in ";
        String className = classText2.getText();
        String method = methodText.getText();
        String params = "";
        StringTokenizer tok = new StringTokenizer(paramsText.getText(), " ;,");
        params += "(";
        while (tok.hasMoreTokens()) {
            params += tok.nextToken();
            params += (tok.hasMoreTokens() ? "," : "");
        }
        params += ")";
        cmd += className + "." + method + params;
        ComponentRepository.getCommandLine().executeCommand(cmd);
        hide();
    }

    private void classMethodClear() {
        classText2.setText("");
        methodText.setText("");
        paramsText.setText("");
    }

    private void cancel() {
        hide();
    }

    public static void main(String[] args) {
        BreakpointDialog d = new BreakpointDialog();
        d.show();
    }
}
