/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
*
* This file is part of the debugger and core tools for the AspectJ(tm)
* programming language; see http://aspectj.org
*
* The contents of this file are subject to the Mozilla Public License
* Version 1.1 (the "License"); you may not use this file except in
* compliance with the License. You may obtain a copy of the License at
* either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
*
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is AspectJ.
*
* The Initial Developer of the Original Code is Xerox Corporation. Portions
* created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
* All Rights Reserved.
*/
package org.aspectj.debugger.gui;

import com.sun.jdi.*;

public class ClassNodeFactory {

    static ClassNode classNode(String name, ReferenceType refType) {
        if (refType != null) name = refType.name();
        String file = AJLineMapper.getSourceFilePathFromAJCClass(name);
        if (file != null && refType != null) return new AJCClassNode(refType);
        if (file != null) return new AJCClassNode(name);
        return new NonAJCClassNode(refType);
    }

    static ClassNode classNode(ReferenceType refType) {
        return ClassNodeFactory.classNode(refType.name(), refType);
    }
}