/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */
package org.aspectj.debugger.gui;

import javax.swing.*;
import java.awt.event.*;

public class CommandLinePanel extends JPanel{
    private JCheckBox cb = new JCheckBox("", false);
    private JComponent jc = null;
    {
        cb.addItemListener(new ItemListener() {
                public void itemStateChanged(ItemEvent e) {
                    jc.setVisible(e.getStateChange() == ItemEvent.DESELECTED ? false : true);
                }
            });
        cb.setToolTipText("Show command line");
    }
    final static GUIDebugger guid() {
        return ComponentRepository.getGUIDebugger();
    }
    public CommandLinePanel(boolean setVisible) {
        this(guid(), setVisible);
    }
    public CommandLinePanel() {
        this(guid());
    }
    public CommandLinePanel(GUIDebugger guid) {
        this(guid, System.getProperty("user.name").equals("palm"));
    }
    public CommandLinePanel(GUIDebugger guid, boolean setVisible) {
        super();
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        add(cb);
        jc = ComponentRepository.getCommandLine();            
        add(jc);
        jc.setVisible(setVisible);
    }
}
