/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */

package org.aspectj.debugger.gui;

import org.aspectj.debugger.base.*;

import java.io.*;

public class EnvTextArea extends AbstractTextArea {

    private PrintStream oldErr = null;
    private PrintStream oldOut = null;

    public EnvTextArea(GUIDebugger guiDebugger) {
        superInit(guiDebugger);
        TextPrintErrStream err = new TextPrintErrStream(this);
        oldErr = System.err;
        //if (!Modes.isForte())
            System.setErr(err);
        TextPrintNoticeStream out = new TextPrintNoticeStream(this);
        oldOut = System.out;
        //if (!Modes.isForte())
            System.setOut(out);
    }

    public void restorePrintStream() {
        if (oldErr != null) System.setErr(oldErr);
        if (oldOut != null) System.setOut(oldOut);
    }

    protected PrintStream createPrintStream() {
        return new TextPrintOutStream(this);
    }

    public String toString() { return d(); }
    public static String d() { return "Env Text Area"; }
}
