/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 */
package org.aspectj.debugger.gui;

import org.aspectj.util.gui.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class StartupScreen extends org.aspectj.util.gui.CenteredJFrame {

    public static void main(String[] args) {
        final StartupScreen ss = new StartupScreen();
        ss.pack();
        ss.setVisible(true);

        Thread thread = new Thread() {
            int i = 0;
            boolean running = true;
            public void run() {
                while (true) {
                    try {
                        if (i == 10) {
                            ss.setVisible(false);
                            ss.dispose();
                            running = false;
                        }
                        ss.setProgress((i++) + "");
                        Thread.sleep(1000);
                    } catch (Exception e) {

                    }
                }
            }
        };
        thread.run();
    }

    final String imageName = "C:\\src\\aspectj.gif";
    JLabel progress;

    public StartupScreen() {
        super("Starting AJDB...");

        JPanel panel = new JPanel();
        panel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
        ImageIcon image = new ImageIcon(imageName);
        panel.add(new JLabel(image));

        progress = new JLabel();
        setProgress("Progress...");
        panel.add(progress);

        getContentPane().add(panel);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

    public void setProgress(String str) {
        progress.setText(str);
    }
}