/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the debugger and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved. 
 */

package org.aspectj.debugger.request;

import org.aspectj.debugger.base.*;

import com.sun.jdi.*;
import com.sun.jdi.event.*;
import com.sun.jdi.request.*;
import java.util.*;

/**
 * ClearAllRequest.java
 *
 *
 * Created: Wed Aug 30 08:51:58 2000
 *
 * @author <a href="mailto:palm@parc.xerox.com"Jeffrey Palm</a>
 */

public class ClearAllRequest extends Request {
    public ClearAllRequest(Debugger debugger) {
        super(debugger);
    }

    public Object go() throws NoVMException, DebuggerException {
        Iterator iter = debugger.getRequests().iterator();
        while (iter.hasNext()) {
            Object o = iter.next();
            if (o instanceof BreakpointRequestAction) {
                debugger.removeRequest((BreakpointRequestAction) o);
            }
        }
        EventRequestManager em = vm().eventRequestManager();
        List breakpointRequests = em.breakpointRequests();
        iter = breakpointRequests.iterator();
        while (iter.hasNext()) {
            BreakpointRequest br = (BreakpointRequest) iter.next();
            em.deleteEventRequest(br);
        }
        return breakpointRequests;
    }
}
